package com.project.gjx;

import java.text.ParseException;
import java.util.List;
import org.jxstar.dao.DaoParam;
import org.jxstar.util.key.KeyCreator;
import org.jxstar.util.MapUtil;
import java.util.Map;
import org.apache.log4j.Logger;
import java.text.SimpleDateFormat;
import org.jxstar.control.action.RequestContext;
import org.jxstar.service.BusinessObject;

public class wareout extends BusinessObject
{
    public String stock(final RequestContext request) throws ParseException {
        final SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        final StringBuffer sb1 = new StringBuffer();
        final String b = "location like '";
        final String c = "%'";
        String d = "";
        final String e = " or ";
        final Logger log = Logger.getLogger((Class)wareout.class);
        final String[] keyids = request.getRequestValues("keyid");
        for (int i = 0; i < 1; ++i) {
            final String keyid = keyids[i];
            final String selsql = "select operid,itemcode,stockqty,qty,in_address from ware_in where in_id=? ";
            final DaoParam param = this._dao.createParam(selsql);
            param.addStringValue(keyid);
            final Map<String, String> inmap = this._dao.queryMap(param);
            if (i == 0) {
                final String del = "delete from ware_out where operid=?";
                final DaoParam param2 = this._dao.createParam(del);
                param2.addStringValue((String)inmap.get("operid"));
                if (!this._dao.update(param2)) {
                    this.setMessage("param12数据操作出错,请联系相关人员");
                    return wareout._returnFaild;
                }
            }
            final String sql34 = "select * from ware_in where operid=?";
            final DaoParam param3 = this._dao.createParam(sql34);
            param3.addStringValue((String)inmap.get("operid"));
            List<Map<String, String>> inlist = this._dao.query(param3);
            for (int z = 0; z < inlist.size(); ++z) {
                Map<String, String> listmap = inlist.get(z);
                final String itemcode = listmap.get("itemcode");
                double firqty = Double.valueOf(listmap.get("stockqty"));
                final String inkeyid = listmap.get("in_id");
                for (int k = 0; k < inlist.size(); ++k) {
                    final Map<String, String> seclistmap = inlist.get(k);
                    final String secinkeyid = seclistmap.get("in_id");
                    final double secqty = Double.valueOf(seclistmap.get("stockqty"));
                    final double sum = firqty + secqty;
                    final String secitemcode = seclistmap.get("itemcode");
                    if (!inkeyid.equals(secinkeyid) && itemcode.equals(secitemcode)) {
                        final String update4 = "update ware_in set stockqty=? where in_id=?";
                        final DaoParam param4 = this._dao.createParam(update4);
                        param4.addStringValue(String.valueOf(sum));
                        param4.addStringValue(inkeyid);
                        this._dao.update(param4);
                        if (!this._dao.update(param4)) {
                            this.setMessage("更新param4失败,请联系系统管理员");
                            log.error((Object)"更新param4失败,请联系系统管理员");
                        }
                        final String del2 = "delete  from ware_in where in_id=?";
                        final DaoParam param5 = this._dao.createParam(del2);
                        param5.addStringValue(secinkeyid);
                        if (!this._dao.update(param5)) {
                            this.setMessage("更新param45失败,请联系系统管理员");
                            log.error((Object)"更新param45失败,请联系系统管理员");
                        }
                        final String sql35 = "select * from ware_in where operid=?";
                        final DaoParam param6 = this._dao.createParam(sql35);
                        param6.addStringValue((String)inmap.get("operid"));
                        inlist = this._dao.query(param6);
                        final String sql36 = "select stockqty from ware_in where in_id=?";
                        final DaoParam param7 = this._dao.createParam(sql36);
                        param7.addStringValue(inkeyid);
                        final Map<String, String> map43 = this._dao.queryMap(param7);
                        firqty = Double.valueOf(map43.get("stockqty"));
                        k = -1;
                        this._log.showError("长度" + inlist.size());
                    }
                }
                listmap = inlist.get(z);
                this._log.showError("长度" + inlist.size() + "物料号" + listmap.get("itemcode") + "另一个" + listmap.get("stockqty") + firqty);
                final String opersql = "select operfromware,operwarecode from ware_oper where id=?";
                final DaoParam param8 = this._dao.createParam(opersql);
                param8.addStringValue((String)listmap.get("operid"));
                final Map<String, String> whcwarmap = this._dao.queryMap(param8);
                final String whcwar = whcwarmap.get("operfromware").substring(0, whcwarmap.get("operfromware").length());
                final String operwarecode = whcwarmap.get("operwarecode");
                final String[] cwar = whcwar.split(";");
                final String selsql2 = "select itemname from base_itemmaster where itemcode=?";
                final DaoParam param9 = this._dao.createParam(selsql2);
                param9.addStringValue((String)listmap.get("itemcode"));
                final Map<String, String> basemap = this._dao.queryMap(param9);
                if (!listmap.get("stockqty").equals("0") && !listmap.get("stockqty").equals(listmap.get("qty"))) {
                    final String updsql3 = "update ware_in set qty=? where in_id=?";
                    final DaoParam param10 = this._dao.createParam(updsql3);
                    param10.addDoubleValue((String)inlist.get(z).get("stockqty"));
                    param10.addStringValue(inkeyid);
                    if (!this._dao.update(param10)) {
                        this.setMessage("更新param2失败,请联系系统管理员");
                        log.error((Object)"更新param2失败,请联系系统管理员");
                    }
                }
                for (int j = 0; j < cwar.length; ++j) {
                    d = sb1.append(String.valueOf(b) + cwar[j] + c + e).toString();
                }
                final String f = "and (" + d.substring(0, d.length() - 4) + ")";
                final String selsql3 = "select qty,unit,location,stockdate,labeltype,labelno,batchno,labelprintdate from ware_stocklabel where itemcode=? and activestatus='1' and location not in('REC','STG') and labeltype in('A1','B2') " + f + "order by labelprintdate";
                final DaoParam param11 = this._dao.createParam(selsql3);
                param11.addStringValue(itemcode);
                final List<Map<String, String>> outlist = this._dao.query(param11);
                if (outlist.size() > 0 & !listmap.get("itemcode").isEmpty()) {
                    final String upsql = "update ware_in set warcstatus=?,operfun=? where itemcode=?";
                    final DaoParam param12 = this._dao.createParam(upsql);
                    param12.addStringValue("仓库有该种物料");
                    param12.addStringValue("WIT");
                    param12.addStringValue(itemcode);
                    if (!this._dao.update(param12)) {
                        this.setMessage("更新param13出错");
                        log.error((Object)"更新param13出错");
                        return wareout._returnFaild;
                    }
                }
                else {
                    final String upsql = "update ware_in set warcstatus=?,operfun=? where itemcode=?";
                    final DaoParam param13 = this._dao.createParam(upsql);
                    param13.addStringValue("仓库无此物料");
                    param13.addStringValue("WIT");
                    param13.addStringValue(itemcode);
                    if (!this._dao.update(param13)) {
                        this.setMessage("更新param14出错");
                        log.error((Object)"更新param14出错");
                        return wareout._returnFaild;
                    }
                }
                if (listmap.get("itemcode").isEmpty()) {
                    final String delsql = "delete from ware_in where in_id=?";
                    final DaoParam param14 = this._dao.createParam(delsql);
                    param14.addStringValue(inkeyid);
                    if (!this._dao.update(param14)) {
                        this.setMessage("删除数据param11出错");
                        log.error((Object)"删除数据param11出错");
                    }
                }
                if (outlist.size() == 0) {
                    final String selsql4 = "select operid,qty,itemcode,in_address from ware_in where in_id=? ";
                    final DaoParam param15 = this._dao.createParam(selsql4);
                    param15.addStringValue(inkeyid);
                    final Map<String, String> inmap2 = this._dao.queryMap(param15);
                    final double outqty = 0.0 - MapUtil.getDouble((Map)inmap2, "qty");
                    final String strdoutqty = String.valueOf(outqty);
                    final String insertsql1 = "insert into ware_out (operid,inlocation,itemname,outlocation,qty,pickqty,out_id,itemcode,batchno,labelno,operfun) values(?,?,?,?,?,?,?,?,?,?,?)";
                    final DaoParam param16 = this._dao.createParam(insertsql1);
                    param16.addStringValue((String)inmap2.get("operid"));
                    param16.addStringValue((String)inmap2.get("in_address"));
                    param16.addStringValue((String)basemap.get("itemname"));
                    param16.addStringValue(" ");
                    param16.addDoubleValue(strdoutqty);
                    param16.addDoubleValue(strdoutqty);
                    param16.addStringValue(KeyCreator.getInstance().createKey("ware_out"));
                    param16.addStringValue((String)inmap2.get("itemcode"));
                    param16.addStringValue("缺货");
                    param16.addStringValue("-");
                    param16.addStringValue("WO");
                    if (!this._dao.update(param16)) {
                        this.setMessage("插入数据param24出错,请联系系统管理员");
                        log.error((Object)"插入数据param24出错,请联系系统管理员");
                        return wareout._returnFaild;
                    }
                    log.error((Object)"是否执行了");
                }
                int l = 0;
                while (l < outlist.size()) {
                    final String selsql5 = "select operid,qty,stockqty,itemcode,in_address from ware_in where in_id=? ";
                    final DaoParam param17 = this._dao.createParam(selsql5);
                    param17.addStringValue(inkeyid);
                    final Map<String, String> inmap3 = this._dao.queryMap(param17);
                    final double outqty2 = MapUtil.getDouble((Map)inmap3, "qty");
                    final String strdoutqty2 = String.valueOf(outqty2);
                    final Map<String, String> outmap = outlist.get(l);
                    final String indate = sdf.format(sdf.parse(outmap.get("labelprintdate")));
                    final double stockqty = MapUtil.getDouble((Map)outmap, "qty");
                    if (stockqty >= outqty2) {
                        final String insertsql2 = "insert into ware_out (operid,inlocation,itemname,outlocation,qty,pickqty,out_id,itemcode,unit,location,indate,labeltype,batchno,lackqty,labelno,operfun,add_date) values(?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,sysdate)";
                        final DaoParam param18 = this._dao.createParam(insertsql2);
                        param18.addStringValue((String)inmap3.get("operid"));
                        param18.addStringValue((String)inmap3.get("in_address"));
                        param18.addStringValue((String)basemap.get("itemname"));
                        param18.addStringValue((String)outmap.get("location"));
                        param18.addDoubleValue(String.valueOf(stockqty));
                        param18.addDoubleValue(strdoutqty2);
                        param18.addStringValue(KeyCreator.getInstance().createKey("ware_out"));
                        param18.addStringValue((String)inmap3.get("itemcode"));
                        param18.addStringValue((String)outmap.get("unit"));
                        param18.addStringValue((String)outmap.get("location"));
                        param18.addDateValue(indate);
                        param18.addStringValue((String)outmap.get("labeltype"));
                        param18.addStringValue((String)outmap.get("batchno"));
                        param18.addDoubleValue(strdoutqty2);
                        param18.addStringValue((String)outmap.get("labelno"));
                        param18.addStringValue("WO");
                        if (!this._dao.update(param18)) {
                            this.setMessage("插入数据param6出错,请联系系统管理员");
                            log.error((Object)"插入数据param6出错,请联系系统管理员");
                            return wareout._returnFaild;
                        }
                        break;
                    }
                    else {
                        final String upsql2 = "update ware_in set qty=qty-? where in_id=?";
                        final DaoParam param19 = this._dao.createParam(upsql2);
                        param19.addDoubleValue((String)outmap.get("qty"));
                        param19.addStringValue(inkeyid);
                        if (!this._dao.update(param19)) {
                            this.setMessage("param8更新出错");
                            log.error((Object)"param8更新出错");
                            return wareout._returnFaild;
                        }
                        final double Douqty = stockqty - outqty2;
                        final String Strqty = String.valueOf(Douqty);
                        if (outlist.size() == 1 || l == outlist.size() - 1) {
                            final String insertsql3 = "insert into ware_out (operid,inlocation,itemname,outlocation,qty,pickqty,out_id,itemcode,unit,location,indate,labeltype,batchno,lackqty,labelno,operfun,add_date) values(?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,sysdate)";
                            final DaoParam param20 = this._dao.createParam(insertsql3);
                            param20.addStringValue((String)inmap3.get("operid"));
                            param20.addStringValue((String)inmap3.get("in_address"));
                            param20.addStringValue((String)basemap.get("itemname"));
                            param20.addStringValue(" ");
                            param20.addDoubleValue(String.valueOf(stockqty));
                            param20.addDoubleValue(Strqty);
                            param20.addStringValue(KeyCreator.getInstance().createKey("ware_out"));
                            param20.addStringValue((String)inmap3.get("itemcode"));
                            param20.addStringValue((String)outmap.get("unit"));
                            param20.addStringValue((String)outmap.get("location"));
                            param20.addDateValue(indate);
                            param20.addStringValue((String)outmap.get("labeltype"));
                            param20.addStringValue("缺货");
                            param20.addDoubleValue(Strqty);
                            param20.addStringValue((String)outmap.get("labelno"));
                            param20.addStringValue("WO");
                            if (!this._dao.update(param20)) {
                                this.setMessage("插入数据param9出错,请联系系统管理员");
                                log.error((Object)"插入数据param9出错,请联系系统管理员");
                                return wareout._returnFaild;
                            }
                            final String insertsql4 = "insert into ware_out (operid,inlocation,itemname,outlocation,qty,pickqty,out_id,itemcode,unit,location,indate,labeltype,batchno,lackqty,labelno,operfun,add_date) values(?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,sysdate)";
                            final DaoParam param21 = this._dao.createParam(insertsql4);
                            param21.addStringValue((String)inmap3.get("operid"));
                            param21.addStringValue((String)inmap3.get("in_address"));
                            param21.addStringValue((String)basemap.get("itemname"));
                            param21.addStringValue((String)outmap.get("location"));
                            param21.addDoubleValue(String.valueOf(stockqty));
                            param21.addDoubleValue(String.valueOf(stockqty));
                            param21.addStringValue(KeyCreator.getInstance().createKey("ware_out"));
                            param21.addStringValue((String)inmap3.get("itemcode"));
                            param21.addStringValue((String)outmap.get("unit"));
                            param21.addStringValue((String)outmap.get("location"));
                            param21.addDateValue(indate);
                            param21.addStringValue((String)outmap.get("labeltype"));
                            param21.addStringValue((String)outmap.get("batchno"));
                            param21.addDoubleValue(Strqty);
                            param21.addStringValue((String)outmap.get("labelno"));
                            param21.addStringValue("WO");
                            if (!this._dao.update(param21)) {
                                this.setMessage("插入数据param29出错,请联系系统管理员");
                                log.error((Object)"插入数据param29出错,请联系系统管理员");
                                return wareout._returnFaild;
                            }
                        }
                        else {
                            final String insertsql3 = "insert into ware_out (operid,inlocation,itemname,outlocation,qty,pickqty,out_id,itemcode,unit,location,indate,labeltype,batchno,lackqty,labelno,operfun,add_date) values(?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,sysdate)";
                            final DaoParam param22 = this._dao.createParam(insertsql3);
                            param22.addStringValue((String)inmap3.get("operid"));
                            param22.addStringValue((String)inmap3.get("in_address"));
                            param22.addStringValue((String)basemap.get("itemname"));
                            param22.addStringValue((String)outmap.get("location"));
                            param22.addDoubleValue(String.valueOf(stockqty));
                            param22.addDoubleValue(String.valueOf(stockqty));
                            param22.addStringValue(KeyCreator.getInstance().createKey("ware_out"));
                            param22.addStringValue((String)inmap3.get("itemcode"));
                            param22.addStringValue((String)outmap.get("unit"));
                            param22.addStringValue((String)outmap.get("location"));
                            param22.addDateValue(indate);
                            param22.addStringValue((String)outmap.get("labeltype"));
                            param22.addStringValue((String)outmap.get("batchno"));
                            param22.addDoubleValue(strdoutqty2);
                            param22.addStringValue((String)outmap.get("labelno"));
                            param22.addStringValue("WO");
                            if (!this._dao.update(param22)) {
                                this.setMessage("插入数据param12出错,请联系系统管理员");
                                log.error((Object)"插入数据param12出错,请联系系统管理员");
                                return wareout._returnFaild;
                            }
                        }
                        ++l;
                    }
                }
            }
        }
        return wareout._returnSuccess;
    }
}
